/// <reference types="react" />
export declare type Unit = {
    [key: string]: any;
    expand?: boolean;
    children?: Array<Unit>;
};
export interface Columns<T> {
    dataIndex?: string;
    key?: string;
    title: string | React.ReactNode;
    width?: number;
    fixed?: 'right' | 'left';
    valueType?: 'selection' | 'checkbox' | 'int' | 'number' | 'date';
    className?: string;
    minWidth?: number;
    hidden?: boolean;
    resize?: boolean;
    paddingLeft?: number;
    paddingRight?: number;
    show?: boolean;
    expandCol?: boolean;
    info?: (text: any, record: T, index: number, width: number) => React.ReactNode;
    render?: (text: any, record: T, index: number, width: number) => React.ReactNode;
}
export interface ExcelProps<T> {
    rowKey?: string | ((key: string) => String);
    className: string;
    height: number;
    width: number;
    columns: Array<Columns<T>>;
    dataSource: Array<T>;
    expandConfig?: {
        expandKey?: string;
        onExpandChange?: (key: string) => Promise<string>;
        defaultExpand?: number;
    };
    onChange?: () => any;
    rowSelection?: {
        selectedRowKeys: Array<string>;
        onChange: any;
    };
    pagination?: {
        total?: number;
        pageSize?: number;
        current?: number;
        onChange?: any;
    };
}
declare global {
    interface Window {
        tExcelResize: boolean;
        stopHover: boolean;
        inPopover: boolean;
    }
}
