function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React from 'react';
import Item from "../item";
import { getRowKeys } from "../../utils/tools";
import "./index.less"; // 网格，表格中没有fixed的内容

var GridColumn = function GridColumn(props) {
  var rowIndex = props.rowIndex,
      style = props.style,
      dataSource = props.dataSource;
  var obj = dataSource[rowIndex];
  return /*#__PURE__*/React.createElement("div", {
    style: style
  }, obj.mergeArr ? obj.mergeArr.map(function (v, index) {
    return /*#__PURE__*/React.createElement(RenderItem, _extends({
      key: index
    }, props, {
      currentData: v,
      extra: {
        rowMergeInfo: {
          mergeDataIndex: index,
          mergeDataField: obj.mergeField,
          mergeData: obj.mergeArr
        }
      }
    }));
  }) : /*#__PURE__*/React.createElement(RenderItem, _extends({}, props, {
    currentData: obj
  })));
};

var RenderItem = function RenderItem(props) {
  var rowIndex = props.rowIndex,
      columnIndex = props.columnIndex,
      dataSource = props.dataSource,
      columnInfo = props.columnInfo,
      changeTable = props.changeTable,
      changeColumns = props.changeColumns,
      changeRedux = props.changeRedux,
      expandKey = props.expandKey,
      rowKey = props.rowKey,
      rowSelection = props.rowSelection,
      _props$extra = props.extra,
      extra = _props$extra === void 0 ? {} : _props$extra,
      currentData = props.currentData;
  var currentColumn = columnInfo.noFixed.data[columnIndex];
  return /*#__PURE__*/React.createElement(Item, _extends({
    key: getRowKeys(rowKey, currentData),
    data: currentData,
    currentColumn: currentColumn,
    expandKey: expandKey,
    change: changeTable,
    changeColumns: changeColumns,
    changeRedux: changeRedux,
    source: dataSource,
    rowIndex: rowIndex,
    columnInfo: columnInfo,
    rowKey: rowKey,
    rowSelection: rowSelection
  }, extra));
};

export default GridColumn;