function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React from 'react';
import Item from "../item";
import { getNormalDpi, sumWidths, getKey } from "../../utils/tools";
import { defaultItemHeightGet } from "../../utils/config";
import "./index.less"; // 构建表格单元格, 需要显示的数据

var columnsBuilder = function columnsBuilder(minRow, maxRow, rowHeight, stickyWidth, dataSource) {
  var rows = [];
  var top = [0],
      pos = 0;

  for (var c = 1; c <= maxRow; c++) {
    pos += rowHeight(c - 1);
    top.push(pos);
  }

  for (var i = minRow; i <= maxRow; i++) {
    rows.push({
      style: {
        position: 'absolute',
        height: rowHeight(i),
        width: stickyWidth,
        top: top[i]
      },
      index: i,
      data: dataSource[i]
    });
  }

  return rows;
};

var StickyColumns = function StickyColumns(props) {
  var stickyWidth = props.stickyWidth,
      minRow = props.minRow,
      maxRow = props.maxRow,
      type = props.type,
      rowHeight = props.rowHeight,
      containerHeight = props.containerHeight,
      dataSource = props.dataSource; // type传值只能是left和right

  var sideStyle = _objectSpread({
    // top: stickyHeight,
    width: stickyWidth - (!getNormalDpi() && type === 'right' ? 1 : 0),
    height: containerHeight
  }, _defineProperty({}, type, 0));

  var sideRows = columnsBuilder(minRow, maxRow, rowHeight, stickyWidth, dataSource);
  return /*#__PURE__*/React.createElement("div", {
    className: "salaryExcelStickyColBox",
    style: sideStyle
  }, sideRows.map(function (_ref) {
    var data = _ref.data,
        index = _ref.index,
        style = _ref.style;
    return /*#__PURE__*/React.createElement("div", {
      style: style,
      key: index
    }, data.mergeArr ? data.mergeArr.map(function (v, i) {
      return /*#__PURE__*/React.createElement(RenderItem, _extends({
        key: i
      }, props, {
        currentData: v,
        rowIndex: index,
        mergeIndex: i,
        extra: {
          rowMergeInfo: {
            mergeDataIndex: i,
            mergeDataField: data.mergeField,
            mergeData: data.mergeArr
          }
        }
      }));
    }) : /*#__PURE__*/React.createElement(RenderItem, _extends({}, props, {
      currentData: data,
      rowIndex: index,
      mergeIndex: 0
    })));
  }));
};

var RenderItem = function RenderItem(props) {
  var columnInfo = props.columnInfo,
      type = props.type,
      dataSource = props.dataSource,
      changeTable = props.changeTable,
      changeColumns = props.changeColumns,
      changeRedux = props.changeRedux,
      rowSelection = props.rowSelection,
      rowKey = props.rowKey,
      expandKey = props.expandKey,
      currentData = props.currentData,
      rowIndex = props.rowIndex,
      mergeIndex = props.mergeIndex,
      _props$extra = props.extra,
      extra = _props$extra === void 0 ? {} : _props$extra;
  var fixedLeft = columnInfo.fixedLeft,
      fixedRight = columnInfo.fixedRight; // type传值只能是left和right

  var sourceDate = type === 'left' ? fixedLeft : fixedRight;
  return sourceDate.data.map(function (v, ii) {
    return /*#__PURE__*/React.createElement("div", {
      key: getKey(v),
      style: {
        position: 'absolute',
        left: sumWidths(sourceDate.source.slice(0, ii)),
        top: mergeIndex * defaultItemHeightGet()
      }
    }, /*#__PURE__*/React.createElement(Item, _extends({
      currentColumn: v,
      data: currentData,
      change: changeTable,
      source: dataSource,
      rowIndex: rowIndex,
      columnInfo: columnInfo,
      changeColumns: changeColumns,
      changeRedux: changeRedux,
      rowSelection: rowSelection,
      rowKey: rowKey,
      expandKey: expandKey
    }, extra)));
  });
};

export default StickyColumns;