import React, { useEffect, useRef } from 'react';
import { defaultItemHeightGet } from "../../utils/config";
import { sumWidths } from "../../utils/tools";
import { plusIcon } from "../../utils/icon";
import classnames from 'classnames';
import "./index.less";
export default function Footer(props) {
  var editableConfig = props.editableConfig,
      gridRef = props.gridRef,
      columnInfo = props.columnInfo,
      changeTable = props.changeTable;
  var touchBottom = useRef({
    flag: false,
    preValue: 0
  });

  var _ref = editableConfig || {},
      editable = _ref.editable,
      showAddBtn = _ref.showAddBtn;

  var height = defaultItemHeightGet();

  var isEndBottom = function () {
    var isShowDirScrollBar = columnInfo.isShowDirScrollBar,
        dataSourceHeightInfo = columnInfo.dataSourceHeightInfo,
        contHeight = columnInfo.contHeight;
    var len = sumWidths(dataSourceHeightInfo);
    var maxHeight = len * height;
    var scrollTop = maxHeight - contHeight;

    if (isShowDirScrollBar) {
      if (gridRef.current && scrollTop === gridRef.current.state.scrollTop) {
        return true;
      } else {
        return false;
      }
    } else {
      return true;
    }
  }();

  useEffect(function () {
    var dataSourceHeightInfo = columnInfo.dataSourceHeightInfo,
        contHeight = columnInfo.contHeight;
    var len = sumWidths(dataSourceHeightInfo);
    if (touchBottom.current.preValue === len) return;
    touchBottom.current.preValue = len;

    if (touchBottom.current.flag) {
      var maxHeight = len * height;
      var scrollTop = maxHeight - contHeight;
      gridRef.current.scrollTo({
        scrollLeft: 0,
        scrollTop: scrollTop
      });
      touchBottom.current.flag = false;
    }
  }, [columnInfo, touchBottom]);

  if (editable && showAddBtn) {
    return /*#__PURE__*/React.createElement("div", {
      style: {
        height: height
      },
      className: classnames('salaryExcelStickyRowFooterBox', {
        salaryExcelStickyRowFooterBoxBottom: isEndBottom
      }),
      onClick: function onClick() {
        touchBottom.current.flag = true;
        changeTable({}, 'addOneData');
      }
    }, /*#__PURE__*/React.createElement("div", {
      className: "salaryExcelStickyRowFooterBoxInner",
      style: {
        width: columnInfo.curMaxWidth
      }
    }, plusIcon, "\u6DFB\u52A0"));
  } else {
    return null;
  }
}