var _excluded = ["children"];

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React, { useContext, useReducer, useEffect } from 'react';
import { VariableSizeGrid as Grid } from 'react-window';
import StickyHeader from "./header";
import StickyFooter from "./footer";
import StickyColumns from "./colSticky";
import GridColumn from "./colGrid";
import classnames from 'classnames';
import { getRenderedCursor } from "../utils/tools";
import { excelClassName, defaultItemHeightGet } from "../utils/config";
import "./index.less";
export var DataCompCxt = /*#__PURE__*/React.createContext(null);
export var DataCompCxtReducer = function DataCompCxtReducer(a, b) {
  return _objectSpread(_objectSpread({}, a), b);
};
export default function Index(props) {
  var className = props.className,
      dataSource = props.dataSource,
      height = props.height,
      width = props.width,
      columnInfo = props.columnInfo,
      nodeRefs = props.nodeRefs,
      onScroll = props.onScroll; // moveLine=>拖拽线  excelBox=>组件总父容器  leftLine=>左阴影线  rightLine=>右阴影线  dragLine=>下拉复制选区  gridRef=>表格  salaryBox=>表格

  var moveLine = nodeRefs.moveLine,
      leftLine = nodeRefs.leftLine,
      rightLine = nodeRefs.rightLine,
      dragLine = nodeRefs.dragLine,
      gridRef = nodeRefs.gridRef,
      salaryBox = nodeRefs.salaryBox,
      modalRef = nodeRefs.modalRef;
  var noFixed = columnInfo.noFixed,
      dataSourceHeightInfo = columnInfo.dataSourceHeightInfo;
  var columnCount = noFixed.source.length; //非固定的总列数

  var rowCount = dataSource.length; //总数据条数

  var columnWidth = function columnWidth(index) {
    return noFixed.source[index];
  }; //单元格宽度方法


  var rowHeight = function rowHeight(index) {
    return dataSourceHeightInfo[index] * defaultItemHeightGet(); //单元格高度方法
  }; // console.log('执行', 'DateComp', '组件');


  var _useReducer = useReducer(DataCompCxtReducer, {}),
      _useReducer2 = _slicedToArray(_useReducer, 2),
      reduxData = _useReducer2[0],
      setReduxData = _useReducer2[1];

  var changeRedux = function changeRedux(param) {
    setReduxData(param);
  };

  useEffect(function () {
    if (gridRef.current) {
      gridRef.current.resetAfterColumnIndex(0, true);
      gridRef.current.resetAfterRowIndex(0, true);
    }
  }, [columnInfo, dataSource]); // 如果使用这个函数来创建表格，会在父组件值变化时候，重新渲染一个新的表格，性能不好
  // const StickyGrid = ({ children, ...rest }: any) => {
  //   return <Grid {...rest}>{children}</Grid>;
  // };
  // ============================================ 渲染render ============================================

  return /*#__PURE__*/React.createElement(DataCompCxt.Provider, {
    value: _objectSpread(_objectSpread({}, props), {}, {
      columnWidth: columnWidth,
      rowHeight: rowHeight,
      changeRedux: changeRedux,
      reduxData: reduxData
    })
  }, /*#__PURE__*/React.createElement("div", {
    className: classnames('salaryExcelBody', className),
    style: {
      height: height,
      width: width
    },
    ref: salaryBox
  }, /*#__PURE__*/React.createElement(Grid, {
    ref: gridRef,
    columnWidth: columnWidth,
    rowHeight: rowHeight,
    innerElementType: InnerElementType,
    className: excelClassName,
    columnCount: columnCount,
    rowCount: rowCount,
    height: height,
    width: width,
    onScroll: onScroll
  }, NewBox), /*#__PURE__*/React.createElement("div", {
    ref: moveLine,
    className: "moveLine"
  }), /*#__PURE__*/React.createElement("div", {
    ref: leftLine,
    className: "leftLine"
  }), /*#__PURE__*/React.createElement("div", {
    ref: rightLine,
    className: "rightLine"
  }), /*#__PURE__*/React.createElement("div", {
    ref: dragLine,
    className: "dragLine"
  }), /*#__PURE__*/React.createElement("div", {
    ref: modalRef,
    className: "modalBox"
  })));
} // ============================================ 表格具体内容的渲染 ============================================

var InnerElementType = function InnerElementType(_ref) {
  var children = _ref.children,
      rest = _objectWithoutProperties(_ref, _excluded);

  var _useContext = useContext(DataCompCxt),
      dataSource = _useContext.dataSource,
      columnInfo = _useContext.columnInfo,
      changeColumns = _useContext.changeColumns,
      changeTable = _useContext.changeTable,
      nodeRefs = _useContext.nodeRefs,
      rowSelection = _useContext.rowSelection,
      rowKey = _useContext.rowKey,
      expandKey = _useContext.expandKey,
      isEmptyData = _useContext.isEmptyData,
      columnWidth = _useContext.columnWidth,
      rowHeight = _useContext.rowHeight,
      changeRedux = _useContext.changeRedux,
      editableConfig = _useContext.editableConfig; // moveLine=>拖拽线  excelBox=>组件总父容器  leftLine=>左阴影线  rightLine=>右阴影线  dragLine=>下拉复制选区  gridRef=>表格  salaryBox=>表格


  var moveLine = nodeRefs.moveLine,
      excelBox = nodeRefs.excelBox,
      salaryBox = nodeRefs.salaryBox,
      gridRef = nodeRefs.gridRef,
      modalRef = nodeRefs.modalRef;
  var fixedRight = columnInfo.fixedRight,
      fixedLeft = columnInfo.fixedLeft,
      noFixed = columnInfo.noFixed,
      hierarchyHeight = columnInfo.hierarchyHeight,
      lenRus = columnInfo.lenRus,
      contHeight = columnInfo.contHeight,
      addBtnHeight = columnInfo.addBtnHeight;
  var stickyWidthLeft = fixedLeft.res; //左边固定列的宽度

  var stickyWidthRight = fixedRight.res; //右边固定列的宽度

  var stickyHeight = hierarchyHeight; //表头的高度
  // 获取可视区域内的坐标值范围

  var _getRenderedCursor = getRenderedCursor(children),
      _getRenderedCursor2 = _slicedToArray(_getRenderedCursor, 4),
      minRow = _getRenderedCursor2[0],
      maxRow = _getRenderedCursor2[1],
      minColumn = _getRenderedCursor2[2],
      maxColumn = _getRenderedCursor2[3];

  var containerStyle = {
    width: lenRus,
    height: isEmptyData ? hierarchyHeight : rest.style.height + hierarchyHeight + addBtnHeight
  };
  var containerHeight = contHeight;
  var gridDataContainerStyle = {
    width: noFixed.res,
    height: containerHeight
  };
  return /*#__PURE__*/React.createElement("div", {
    className: "salaryExcelContainer",
    style: containerStyle
  }, /*#__PURE__*/React.createElement(StickyHeader, {
    columnWidth: columnWidth,
    stickyHeight: stickyHeight,
    stickyWidthRight: stickyWidthRight,
    stickyWidthLeft: stickyWidthLeft,
    columnInfo: columnInfo,
    dataSource: dataSource,
    minColumn: minColumn,
    maxColumn: maxColumn,
    moveLine: moveLine,
    excelBox: excelBox,
    changeColumns: changeColumns,
    changeRedux: changeRedux,
    changeTable: changeTable,
    rowSelection: rowSelection,
    rowKey: rowKey,
    salaryBox: salaryBox
  }), !isEmptyData && /*#__PURE__*/React.createElement("div", {
    className: "dataBox",
    style: {
      height: rest.style.height
    },
    onMouseLeave: function onMouseLeave() {
      if (modalRef.current.style.display === 'block' || window.inPopover) {
        return;
      }

      changeRedux({
        mergeHoverIndex: undefined
      });
    }
  }, /*#__PURE__*/React.createElement(StickyColumns, {
    type: "left",
    containerHeight: containerHeight,
    rowHeight: rowHeight,
    stickyHeight: stickyHeight,
    stickyWidth: stickyWidthLeft,
    columnInfo: columnInfo,
    dataSource: dataSource,
    minRow: minRow,
    maxRow: maxRow,
    changeTable: changeTable,
    changeColumns: changeColumns,
    changeRedux: changeRedux,
    rowSelection: rowSelection,
    rowKey: rowKey,
    expandKey: expandKey
  }), /*#__PURE__*/React.createElement("div", {
    className: "dataBoxBox",
    style: gridDataContainerStyle
  }, children), /*#__PURE__*/React.createElement(StickyColumns, {
    type: "right",
    containerHeight: containerHeight,
    rowHeight: rowHeight,
    stickyHeight: stickyHeight,
    stickyWidth: stickyWidthRight,
    columnInfo: columnInfo,
    dataSource: dataSource,
    minRow: minRow,
    maxRow: maxRow,
    changeTable: changeTable,
    changeColumns: changeColumns,
    changeRedux: changeRedux,
    expandKey: expandKey,
    rowKey: rowKey,
    rowSelection: rowSelection
  })), /*#__PURE__*/React.createElement(StickyFooter, {
    editableConfig: editableConfig,
    gridRef: gridRef,
    dataSource: dataSource,
    columnInfo: columnInfo,
    rowKey: rowKey,
    changeTable: changeTable
  }));
}; // ============================================ 表格中心格子的渲染 ============================================


var NewBox = function NewBox(props) {
  var _useContext2 = useContext(DataCompCxt),
      dataSource = _useContext2.dataSource,
      columnInfo = _useContext2.columnInfo,
      changeColumns = _useContext2.changeColumns,
      changeTable = _useContext2.changeTable,
      rowSelection = _useContext2.rowSelection,
      rowKey = _useContext2.rowKey,
      expandKey = _useContext2.expandKey,
      changeRedux = _useContext2.changeRedux;

  return /*#__PURE__*/React.createElement(GridColumn, _extends({}, props, {
    expandKey: expandKey,
    dataSource: dataSource,
    columnInfo: columnInfo,
    changeTable: changeTable,
    changeColumns: changeColumns,
    changeRedux: changeRedux,
    rowKey: rowKey,
    rowSelection: rowSelection
  }));
};