function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React from 'react';
import Checked, { TYPE as CheckType } from "../../Checked";
import Ellipsis from "../../components/Ellipsis";
import classnames from 'classnames';
import { caretRight, caretDown, loadingIcon, delIcon } from "../../utils/icon";
import { getPrimary, getKey, getRowKeys, getErrorDisabled } from "../../utils/tools";
import { defaultItemHeightGet } from "../../utils/config";
import { AssistIcon } from "./assistIcon";
import "./index.less";
import Undertake from "../../undertake";
import { areEqual } from "../../validate";
var preSpClickFlag = false; // 所有单元格cell都使用这个组件，但是这个Item只是起到分流的作用
// 原因：3个表头合并，带来的结果是数据单元格就是3个一组

var Item = function Item(props) {
  var currentColumn = props.currentColumn;
  var children = currentColumn.children;
  return children ? /*#__PURE__*/React.createElement("div", {
    className: "salaryExcelDataItemBox"
  }, children.map(function (v, index) {
    return /*#__PURE__*/React.createElement(Cell, _extends({
      key: getKey(v)
    }, props, {
      currentColumn: v,
      index: index
    }));
  })) : /*#__PURE__*/React.createElement(Cell, _extends({}, props, {
    currentColumn: currentColumn,
    index: 0
  }));
}; // 正儿八经的单元格


var CellCtx = /*#__PURE__*/React.memo(function (props) {
  // console.log('Item-re-render');
  var rowSelection = props.rowSelection,
      rowKey = props.rowKey,
      expandKey = props.expandKey,
      change = props.change,
      changeRedux = props.changeRedux,
      rowIndex = props.rowIndex,
      columnInfo = props.columnInfo,
      rowMergeInfo = props.rowMergeInfo,
      excelContext = props.excelContext,
      source = props.source,
      data = props.data,
      currentColumn = props.currentColumn,
      index = props.index;

  var _ref = rowMergeInfo || {},
      mergeDataIndex = _ref.mergeDataIndex,
      mergeDataField = _ref.mergeDataField,
      mergeData = _ref.mergeData;

  var dataSourceHeightInfo = columnInfo.dataSourceHeightInfo;
  var isMergeRow = dataSourceHeightInfo.find(function (v) {
    return v > 1;
  }) > -1;
  var isOdd = isMergeRow ? false : rowIndex % 2 !== 0; //是否奇数行

  var reduxData = excelContext.reduxData;

  var _ref2 = rowSelection || {},
      _ref2$selectedRowKeys = _ref2.selectedRowKeys,
      selectedRowKeys = _ref2$selectedRowKeys === void 0 ? [] : _ref2$selectedRowKeys;

  var selectOneRow = reduxData.selectOneRow,
      editableConfig = reduxData.editableConfig,
      hoverRowHighlight = reduxData.hoverRowHighlight,
      defaultShowCtx = reduxData.defaultShowCtx,
      crosswalk = reduxData.crosswalk;
  var editable = editableConfig.editable,
      hoverRowShowDel = editableConfig.hoverRowShowDel,
      _editableConfig$error = editableConfig.errors,
      errors = _editableConfig$error === void 0 ? [] : _editableConfig$error,
      _editableConfig$disab = editableConfig.disabled,
      disabledProps = _editableConfig$disab === void 0 ? [] : _editableConfig$disab;
  var width = currentColumn.width,
      valueType = currentColumn.valueType,
      info = currentColumn.info,
      lastCol = currentColumn.lastCol,
      disabled = currentColumn.disabled,
      render = currentColumn.render;
  var dataIndex = getKey(currentColumn);
  var dataRowId = getRowKeys(rowKey, data); // 编辑态+不等于【显示斑马线】  或者  显示态+【显示斑马线】

  if (editable && crosswalk !== true || !editable && crosswalk === false) {
    isOdd = false;
  }

  var errorStatus = getErrorDisabled(errors, dataIndex, dataRowId);
  var isDisabled = disabled || !!getErrorDisabled(disabledProps, dataIndex, dataRowId);

  var preSpClick = function preSpClick() {
    if (preSpClickFlag) return;
    preSpClickFlag = true;
    change({
      dataRowId: dataRowId,
      data: data
    }, 'delOneRow');
    setTimeout(function () {
      preSpClickFlag = false;
    }, 100);
  };

  var getLabel = function getLabel(ctxWidth) {
    var dataItem = data[dataIndex]; // 获取 dataIndex || key 指定的数据

    var renderItem = render || function (v) {
      return v;
    };

    var result = renderItem(dataItem, data, rowIndex, ctxWidth, {
      mergeData: mergeData,
      mergeDataIndex: mergeDataIndex
    });
    var defaultShowText = defaultShowCtx === undefined ? '-' : defaultShowCtx;
    return [result === undefined ? defaultShowText : result, dataItem];
  }; // 现有场景：如果表头有合并了2个单元格，那么数据区域就需要连着渲染2个单元格，index标明了是第几个单元格


  var itemMergeMultiple = 1;

  if (mergeDataIndex !== undefined) {
    var mergeColObj = (mergeDataField || []).find(function (v) {
      return v.key === dataIndex;
    }); // 如果mergeColObj存在 => 需要合并 => 取mergeColObj的area字段 => 范围控制

    if (mergeColObj) {
      var placeTarget = mergeColObj.area.find(function (v) {
        if (v && v.length === 2) {
          return mergeDataIndex >= v[0] && mergeDataIndex <= v[1];
        } else {
          return false;
        }
      });

      if (placeTarget) {
        var _placeTarget = _slicedToArray(placeTarget, 2),
            mergeColAreaMin = _placeTarget[0],
            mergeColAreaMax = _placeTarget[1];

        if (mergeDataIndex === mergeColAreaMin) {
          itemMergeMultiple = mergeColAreaMax - mergeColAreaMin + 1;
        } else if (mergeDataIndex > mergeColAreaMin && mergeDataIndex <= mergeColAreaMax) {
          return null;
        }
      }
    }
  } // 第一个列内的第一个单元格，并且这个单元格标明了要显示图标 => 缩进特殊处理


  var isNeedPd = data.expandShowIcon !== false && currentColumn.expandCol && index === 0; // 需要根据第一行数据是否显示图标来计算出具体的缩进距离

  var extraW = 0;

  if (isNeedPd) {
    extraW = (data.hierarchy - (source[0].expandShowIcon !== false ? 0 : 1)) * 20;
  } // 先减掉左右固定的10 + 10的padding


  var ctxWidth = width - 20;

  if (info) {
    ctxWidth -= 20;
  }

  if (isNeedPd) {
    ctxWidth -= extraW;
  }

  if (ctxWidth <= 22) {
    ctxWidth = 22;
    extraW = width - ctxWidth;
  }

  var _getLabel = getLabel(ctxWidth),
      _getLabel2 = _slicedToArray(_getLabel, 2),
      label = _getLabel2[0],
      labelText = _getLabel2[1];

  return /*#__PURE__*/React.createElement(AssistIcon, {
    excelContext: excelContext,
    data: data,
    source: source,
    rowIndex: rowIndex,
    param: _objectSpread(_objectSpread({}, currentColumn), {}, {
      disabled: isDisabled
    }),
    rowKey: rowKey,
    change: change,
    key: dataIndex,
    width: width,
    fatherTmp: /*#__PURE__*/React.createElement("div", {
      className: getPrimary(classnames('salaryExcelDataItem', {
        salaryExcelDataItemHover: reduxData.mergeHoverIndex === rowIndex,
        salaryExcelDataItemGrey: isOdd,
        salaryExcelDataItemDisabled: isDisabled,
        intValueStyle: ['int', 'number'].includes(valueType) && (true || !editable),
        lastColHiddenBorder: lastCol,
        salaryExcelDataItemChecked: selectedRowKeys.includes(getRowKeys(rowKey, data)),
        salaryExcelDataItemHigtlight: dataIndex === 'rowPrefixSp' && selectOneRow && selectOneRow.rowIndex === rowIndex
      })),
      onMouseEnter: function onMouseEnter() {
        if (window.stopHover) return;

        if (hoverRowHighlight) {
          changeRedux({
            mergeHoverIndex: rowIndex
          });
        }
      },
      style: {
        width: width,
        height: defaultItemHeightGet() * itemMergeMultiple
      }
    }),
    childrenTmp: /*#__PURE__*/React.createElement(React.Fragment, null, dataIndex === 'rowSelection' ? /*#__PURE__*/React.createElement(Checked, {
      type: CheckType.ctx,
      data: data,
      rowKey: rowKey,
      rowSelection: rowSelection
    }) : dataIndex === 'rowPrefixSp' ? /*#__PURE__*/React.createElement("div", {
      className: "salaryExcelDataItemPrefixSp",
      onClick: preSpClick
    }, hoverRowShowDel && reduxData.mergeHoverIndex === rowIndex ? delIcon : rowIndex + 1) : /*#__PURE__*/React.createElement(React.Fragment, null, isNeedPd && /*#__PURE__*/React.createElement("div", {
      className: "salaryExcelArrow",
      style: {
        width: extraW
      }
    }, /*#__PURE__*/React.createElement("span", {
      onClick: function onClick() {
        return change(data, 'toggleRowExpand');
      }
    }, data.expandShowIcon !== false && data.expand && (reduxData.loadingExpandId === data[expandKey] ? loadingIcon : data.expandStatus ? caretDown : caretRight))), /*#__PURE__*/React.createElement(Ellipsis, {
      text: label,
      width: ctxWidth,
      stopHover: errorStatus ? !!errorStatus.errorMsg : false
    }), info && /*#__PURE__*/React.createElement("div", {
      className: "salaryExcelDataInfo"
    }, info(labelText, data, rowIndex, ctxWidth))))
  });
}, areEqual);
var Cell = Undertake(CellCtx);
export default Item;