import React, { useRef, useEffect } from 'react';
import { removeDom, getRefBounding, stopHoverFn, renderPopover } from "./common";
// 拖动的时候要阻止hover，
export default function Popover1(props) {
  var content = props.content,
      children = props.children,
      _props$canCopy = props.canCopy,
      canCopy = _props$canCopy === void 0 ? true : _props$canCopy;
  var curSpanRef = useRef();
  var timer = useRef();
  var pDiv = useRef(document.createElement('div'));
  useEffect(function () {
    return function () {
      hideDiv();
    };
  }, []);

  var hideDiv = function hideDiv() {
    window.inPopover = true;
    removeDom(pDiv.current);
  };

  var onMouseEnter = function onMouseEnter() {
    if (stopHoverFn()) return;
    var info = getRefBounding(curSpanRef);
    clearDelayTimer();
    renderPopover(info.top, info.left, info.width, content, pDiv, onPopMouseEnter, hideDiv);
  }; // 鼠标移出，开一个定时器，100ms后关闭弹窗


  var onMouseLeave = function onMouseLeave() {
    if (stopHoverFn()) return;

    if (canCopy) {
      window.inPopover = true;
      timer.current = window.setTimeout(function () {
        hideDiv();
        clearDelayTimer();
      }, 100);
    } else {
      hideDiv();
    }
  }; // 鼠标移入弹窗就取消上面那个100ms的定时器，弹窗也不会消失了


  var onPopMouseEnter = function onPopMouseEnter() {
    if (!canCopy) return;
    clearDelayTimer();
  };

  var clearDelayTimer = function clearDelayTimer() {
    if (timer.current) {
      clearTimeout(timer.current);
      timer.current = null;
    }
  };

  return /*#__PURE__*/React.createElement("div", {
    ref: curSpanRef,
    onMouseEnter: onMouseEnter,
    onMouseLeave: onMouseLeave
  }, children);
}